## fdb 5.19.0

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.18 FATAL_ERROR )

find_package( ecbuild 3.12 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( fdb5 LANGUAGES C CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
# set(CMAKE_COMPILE_WARNING_AS_ERROR ON)
# add_compile_options(-fsanitize=address)
# add_compile_options(-fsanitize=address,undefined -fno-omit-frame-pointer)
# add_link_options(-fsanitize=address)
# set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-unused-variable -Wno-sign-compare")
# set(CMAKE_CXX_FLAGS "-Wno-unused-parameter -Wno-unused-variable -Wno-reorder -Wno-sign-compare -Wvla-cxx-extension")

CHECK_TYPE_SIZE(off_t SIZEOF_OFF_T)

if ("${SIZEOF_OFF_T}" LESS 8)
    MESSAGE(SEND_ERROR "Missing support for large files (off_t size < 64 bits)")
endif()

########################################################################################################################
### dependencies and options

### Documentation
ecbuild_add_option( FEATURE FDB_DOCUMENTATION
                    DEFAULT OFF
                    DESCRIPTION "Enable documentation generation" )

### eckit

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_find_package( NAME eckit  VERSION 1.32 REQUIRED )

### GRIB support

ecbuild_find_package( NAME eccodes VERSION 2.10 QUIET )

ecbuild_add_option( FEATURE GRIB
                    DEFAULT ON
                    CONDITION eccodes_FOUND
                    DESCRIPTION "Support for GRIB via eccodes")

ecbuild_find_package( NAME metkit VERSION 1.15 REQUIRED )

### FDB backend in CEPH object store (using Rados)

find_package( RADOS QUIET )
ecbuild_add_option( FEATURE RADOSFDB  # option defined in fdb5_config.h
                    CONDITION eckit_HAVE_RADOS AND RADOS_FOUND
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados support for FDB Store" )

### FDB backend in indexed filesystem with table-of-contents, i.e. TOC
### Supports Lustre parallel filesystem stripping control

ecbuild_add_option( FEATURE TOCFDB  # option defined in fdb5_config.h
                    DEFAULT ON
                    DESCRIPTION "Filesystem TOC support for FDB" )

### support for Lustre API control of file stripping

find_package( LUSTREAPI QUIET )

ecbuild_add_option( FEATURE LUSTRE  # option defined in fdb5_config.h
                    CONDITION LUSTREAPI_FOUND
                    DEFAULT ON
                    DESCRIPTION "Support for Lustre API control of file stripping " )

### experimental & sandbox features

ecbuild_add_option( FEATURE FDB_REMOTE
                    DEFAULT ON
                    DESCRIPTION "Support for FDB remote access" )

find_package(LibUUID QUIET)

find_package(DAOS QUIET)


set(_default_dummy_daos ON)
if(DAOS_FOUND)
    set(_default_dummy_daos OFF)
endif()

ecbuild_add_option( FEATURE DUMMY_DAOS
                    DEFAULT ${_default_dummy_daos}
                    CONDITION LibUUID_FOUND
                    DESCRIPTION "Use dummy DAOS library emulating DAOS with a file system" )

if(HAVE_DUMMY_DAOS)
    set(DAOS_LIBRARIES dummy_daos)
    set(DAOS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
    set(DAOS_FOUND TRUE)
    set(DAOS_TESTS_LIBRARIES dummy_daos_tests)
    set(DAOS_TESTS_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src/dummy_daos)
    set(DAOS_TESTS_FOUND TRUE)
endif()

ecbuild_add_option( FEATURE DAOSFDB
                    CONDITION DAOS_FOUND AND LibUUID_FOUND
                    DEFAULT ON
                    DESCRIPTION "DAOS support for FDB Store" )

ecbuild_add_option( FEATURE DAOS_ADMIN
                    DEFAULT ${_default_dummy_daos}
                    CONDITION HAVE_DAOSFDB AND DAOS_TESTS_FOUND
                    DESCRIPTION "Add features for DAOS pool management. Removes need to manually create a pool for DAOS unit tests" )

# DAOS_TESTS is a daos admin library, usually not present
if(NOT HAVE_DAOS_ADMIN)
    set( DAOS_TESTS_LIBRARIES "" )
    set( DAOS_TESTS_INCLUDE_DIRS "" )
endif()

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features" )

ecbuild_add_option( FEATURE SANDBOX
                    DESCRIPTION "build the sandbox stuff"
                    DEFAULT OFF	 )

ecbuild_add_option( FEATURE PYTHON_ZARR_INTERFACE
                    DESCRIPTION "Build python Zarr interface layer"
                    DEFAULT OFF
                    REQUIRED_PACKAGES "NAME pybind11 VERSION 3.0.1" )
if(HAVE_PYTHON_ZARR_INTERFACE)
    find_package(Python 3.11 COMPONENTS Interpreter Development REQUIRED)
endif()


### build the tools

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

if(HAVE_BUILD_TOOLS)
    set(_default_fdb_tools ON)
else()
    set(_default_fdb_tools OFF)
endif()

ecbuild_add_option( FEATURE FDB_BUILD_TOOLS
                    DEFAULT ${_default_fdb_tools}
                    DESCRIPTION "Build the command line FDB tools" )

### find thread library ( preferably pthreads )

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package(Threads REQUIRED)

### checks

# check thread library is pthreads

if( NOT ${CMAKE_USE_PTHREADS_INIT} )
	message( FATAL_ERROR "Only pthreads supported - thread library found is [${CMAKE_THREAD_LIBS_INIT}]" )
endif()

########################################################################################################################
# contents

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( fdb5_INCLUDE_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

include_directories( ${fdb5_INCLUDE_DIRS} )

set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS};${ECCODES_DEFINITIONS}" )

get_directory_property( fdb5_DEFINITIONS COMPILE_DEFINITIONS )

### source files

add_subdirectory( src )
add_subdirectory( tests )

### finalize
if(ENABLE_FDB_DOCUMENTATION)
    add_subdirectory(docs)
endif()


ecbuild_install_project( NAME fdb )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
############################################################################################
# libraries

ecbuild_find_project_files()

add_subdirectory(fdb5)
add_subdirectory(chunked_data_view)

if (HAVE_PYTHON_ZARR_INTERFACE)
    # We create the complete python package layout at this location.
    # This allows us to run python wheel creation at this path and 
    # to put this path on the PYTHONPATH to allow direct use of
    # z3fdb, e.g. for testing or local exploration.
    set(Z3FDB_STAGING "${CMAKE_BINARY_DIR}/z3fdb-python-package-staging")
    file(MAKE_DIRECTORY "${Z3FDB_STAGING}")
    file(CREATE_LINK
        "${CMAKE_CURRENT_SOURCE_DIR}/z3fdb"
        "${Z3FDB_STAGING}/z3fdb" SYMBOLIC
    )
    file(CREATE_LINK
        "${CMAKE_CURRENT_SOURCE_DIR}/pychunked_data_view"
        "${Z3FDB_STAGING}/pychunked_data_view" SYMBOLIC
    )
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/../cmake/z3fdb_setup.py.in
        ${Z3FDB_STAGING}/setup.py
        @ONLY
    )
    add_subdirectory(chunked_data_view_bindings)
    set(_z3fdb_package_files
        "z3fdb/simple_store_builder.py"
        "z3fdb/z3fdb_error.py"
        "z3fdb/__init__.py"
        "z3fdb/_internal/zarr.py"
        "pychunked_data_view/__init__.py"
        "pychunked_data_view/chunked_data_view.py"
        "pychunked_data_view/exceptions.py"
    )
    add_custom_command(
        OUTPUT ${CMAKE_BINARY_DIR}/wheel.stamp
        COMMAND ${Python_INTERPRETER} -m build --wheel ${Z3FDB_STAGING} -o .
        COMMAND ${CMAKE_COMMAND} -E touch wheel.stamp
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        DEPENDS 
            ${_z3fdb_package_files}
            $<TARGET_FILE:chunked_data_view_bindings>
        COMMENT "Building Python wheel for z3fdb..."
    )
    add_custom_target(z3fdb-wheel ALL DEPENDS ${CMAKE_BINARY_DIR}/wheel.stamp)
endif()

if (HAVE_DUMMY_DAOS)
	add_subdirectory(dummy_daos)
endif()

=== tests/CMakeLists.txt ===
# Unit tests

# If eccodes MEMFS is disabled, set the definition and samples path 
# env variables for all tests, picking the values defined for these 
# paths in the eccodes CMakeLists.txt

set( test_environment "" )

if (NOT eccodes_HAVE_MEMFS)
    list( APPEND test_environment 
        ECCODES_DEFINITION_PATH=${ECCODES_DEFINITION_PATH}
        ECCODES_SAMPLES_PATH=${ECCODES_SAMPLES_PATH})
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

add_subdirectory( fdb )
add_subdirectory( chunked_data_view )
add_subdirectory( regressions )

if (HAVE_PYTHON_ZARR_INTERFACE)
    add_subdirectory( z3fdb )
    add_subdirectory( pychunked_data_view )
endif()

=== docs/z3fdb/CMakeLists.txt ===
find_package(Sphinx REQUIRED)

file(GLOB_RECURSE SPHINX_INPUT_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.rst)
set(SPHINX_INDEX_FILE ${CMAKE_CURRENT_BINARY_DIR}/sphinx/index.html)

add_custom_command(
    DEPENDS 
        ${SPHINX_INPUT_FILES}
        conf.py
    COMMAND
        SPHINX_EXECUTABLE=${SPHINX_EXECUTABLE}
        DOCBUILD_OUTPUT=${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}/build_docs.sh
    COMMENT "Generating documentation for z3fdb"
    OUTPUT ${SPHINX_INDEX_FILE}
)

add_custom_target(z3fdb-doc ALL DEPENDS ${SPHINX_INDEX_FILE})

=== docs/z3fdb/requirements.txt ===
sphinxcontrib-mermaid~=1.0
pydata-sphinx-theme==0.16.1
Sphinx~=8.2.3
sphinx-autoapi~=3.6.0
sphinx-tabs~=3.4.7

=== src/chunked_data_view/CMakeLists.txt ===
include(parse_semver)
parse_semver(${CMAKE_CURRENT_SOURCE_DIR}/../../VERSION chunked_data_view)
message(STATUS "With 'chunked_data_view' [${chunked_data_view_VERSION_STRING}]")
configure_file(
    chunked_data_view_version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/chunked_data_view_version.h
    @ONLY
)

add_library(chunked_data_view STATIC
    ${CMAKE_CURRENT_BINARY_DIR}/chunked_data_view_version.h
    Axis.cc
    Axis.h
    Buffer.cc
    ChunkedDataViewBuilder.cc
    ChunkedDataViewImpl.cc
    ChunkedDataViewImpl.h
    Extractor.cc
    Fdb.cc
    GribExtractor.cc
    GribExtractor.h
    IndexMapper.cc
    IndexMapper.h
    LibChunkedDataView.cc
    ListIterator.cc
    RequestManipulation.cc
    RequestManipulation.h
    ViewPart.cc
    ViewPart.h
    include/chunked_data_view/AxisDefinition.h
    include/chunked_data_view/Buffer.h
    include/chunked_data_view/ChunkedDataView.h
    include/chunked_data_view/ChunkedDataViewBuilder.h
    include/chunked_data_view/DataLayout.h
    include/chunked_data_view/Extractor.h
    include/chunked_data_view/Fdb.h
    include/chunked_data_view/LibChunkedDataView.h
    include/chunked_data_view/ListIterator.h
)

target_include_directories(chunked_data_view
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/include
    PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(chunked_data_view
    PRIVATE
        eckit
        metkit
        fdb5
)

=== src/chunked_data_view_bindings/CMakeLists.txt ===
pybind11_add_module(chunked_data_view_bindings MODULE bindings.cc)

target_link_libraries(chunked_data_view_bindings
    PRIVATE pybind11::module 
            pybind11::lto 
            chunked_data_view
            eckit
            metkit
            fdb5
            # We need to explicity link to stdc++fs on gcc 8.x
            $<$<AND:$<CXX_COMPILER_ID:GNU>,$<VERSION_GREATER_EQUAL:$<CXX_COMPILER_VERSION>,8.0>,$<VERSION_LESS:$<CXX_COMPILER_VERSION>,9.0>>:stdc++fs>
)

# pybind11_extension(pychunked_data_view)
if(NOT MSVC AND NOT ${CMAKE_BUILD_TYPE} MATCHES Debug|RelWithDebInfo)
    # Strip unnecessary sections of the binary on Linux/macOS
    pybind11_strip(chunked_data_view_bindings)
endif()

set_target_properties(chunked_data_view_bindings
  PROPERTIES 
  LIBRARY_OUTPUT_DIRECTORY ${Z3FDB_STAGING}/chunked_data_view_bindings
)

=== tests/fdb/CMakeLists.txt ===
configure_file( etc/mars/wind       ${PROJECT_BINARY_DIR}/etc/mars/wind       @ONLY )

configure_file( etc/fdb/config.yaml ${PROJECT_BINARY_DIR}/etc/fdb/config.yaml @ONLY )
configure_file( etc/fdb/schema      ${PROJECT_BINARY_DIR}/etc/fdb/schema      @ONLY )
#configure_file( etc/fdb/engines  ${CMAKE_BINARY_DIR}/etc/fdb/engines   @ONLY )

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file
file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/root2 ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/roots file

file( MAKE_DIRECTORY ${PROJECT_BINARY_DIR}/tests/fdb/pool ) # as defined in ${CMAKE_BINARY_DIR}/etc/fdb/pools file

###############################################################################
# fdb unit tests

set( _test_environment ${test_environment})

list( APPEND _test_environment
    FDB_HOME=${PROJECT_BINARY_DIR} )

list( APPEND fdb_tests
    test_fdb5_service.cc )

foreach( _tst ${fdb_tests} )

  get_filename_component(_test_name ${_tst} NAME_WE)

  ecbuild_add_test(
      TARGET  fdb5_${_test_name}
      SOURCES  ${_tst}
      INCLUDES ${ECCODES_INCLUDE_DIRS}
      ENVIRONMENT "${_test_environment}"
      LIBS  fdb5 )

endforeach()

###############################################################################
# fdb tool tests

list( APPEND _test_data
  "rd.vod.grib"
)

ecbuild_get_test_multidata( TARGET fdb5_get_test_data NAMES ${_test_data} NOCHECK )

foreach( _tst ${_test_data} )

    # define tool location using cmake-generator-expressions
    # see https://cmake.org/cmake/help/v3.4/manual/cmake-generator-expressions.7.html

    ecbuild_add_test(
        TARGET  fdb5_archive_${_tst}
        CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
        COMMAND $<TARGET_FILE:fdb-write>
        TEST_DEPENDS fdb5_get_test_data
        ARGS    ${_tst}
        ENVIRONMENT "${_test_environment}" )

      ecbuild_add_test(
          TARGET  fdb5_extract_${_tst}
          CONDITION HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB
          COMMAND $<TARGET_FILE:fdb-read>
          TEST_DEPENDS fdb5_archive_${_tst}
          ARGS   --extract ${_tst} ${_tst}.2
          ENVIRONMENT "${_test_environment}" )

endforeach()

add_subdirectory( api )
add_subdirectory( database )
add_subdirectory( tools )
add_subdirectory( type )
add_subdirectory( daos )

if (HAVE_FDB_REMOTE)
    add_subdirectory( remote )
endif()

=== tests/pychunked_data_view/CMakeLists.txt ===
function(add_py_test test)
    get_filename_component(stem ${test} NAME_WLE)
    add_test(
        NAME pychunked_data_view_${stem}
        COMMAND ${Python_INTERPRETER}
            -m pytest
            --basetemp ${CMAKE_CURRENT_BINARY_DIR}/pytest-tmp
            -vv -s ${CMAKE_CURRENT_SOURCE_DIR}/${test}
    )
    set(_env
        "PYTHONPATH=${CMAKE_BINARY_DIR}/z3fdb-python-package-staging"
        #prevent findlibs in pyfdb to pickup any globally installed fdb
        "FDB5_DIR=${CMAKE_BINARY_DIR}"
        #prevent findlibs in eccodes-python to pickup any globally installed eccodes
        "FINDLIBS_DISABLE_PACKAGE=yes"
        "ECCODES_DIR=$<TARGET_FILE_DIR:eccodes>/.."
    )
    set_tests_properties(pychunked_data_view_${stem}
        PROPERTIES
        RESOURCE_LOCK pytest
        ENVIRONMENT "${_env}"
        LABELS z3fdb
    )
endfunction()


set(test_files
    test_chunked_data_view.py
)

foreach(test_file ${test_files})
    add_py_test(${test_file})
endforeach()

=== tests/regressions/CMakeLists.txt ===
if (HAVE_FDB_BUILD_TOOLS) # test scripts use the fdb tools

    if (HAVE_GRIB)
        add_subdirectory(FDB-238)
        add_subdirectory(FDB-239)
        add_subdirectory(FDB-240)
        add_subdirectory(FDB-243)
        add_subdirectory(FDB-245)
        add_subdirectory(FDB-251)
        add_subdirectory(FDB-260)
        add_subdirectory(FDB-264)
        add_subdirectory(FDB-266)
        add_subdirectory(FDB-267)
        add_subdirectory(FDB-268)
        add_subdirectory(FDB-271)
        add_subdirectory(FDB-275)
        add_subdirectory(FDB-276)
        add_subdirectory(FDB-282)
        add_subdirectory(FDB-291)
        add_subdirectory(FDB-292)
        add_subdirectory(FDB-303)
        add_subdirectory(FDB-307)
        add_subdirectory(FDB-310)
        add_subdirectory(FDB-332)
        add_subdirectory(FDB-533)
        add_subdirectory(FDB-535)
        add_subdirectory(FDB-541)
    endif()

    add_subdirectory(FDB-241)

    if (HAVE_FDB_REMOTE)
        add_subdirectory(FDB-419)
        
        if (HAVE_GRIB)
            add_subdirectory(FDB-610)
            add_subdirectory(FDB-258)
            add_subdirectory(FDB-491)
            add_subdirectory(FDB-595)
        endif()

    endif()

endif()

# Tests not using the fdb tools
add_subdirectory(FDB-425)

=== tests/regressions/FDB-533/CMakeLists.txt ===
ecbuild_configure_file( FDB-533.sh.in FDB-533.sh @ONLY )

ecbuild_add_test(
    TYPE     SCRIPT
    COMMAND  FDB-533.sh
    ENVIRONMENT "${test_environment}" )

=== tests/regressions/FDB-610/CMakeLists.txt ===
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/FDB-610.sh.in"
    "${CMAKE_CURRENT_BINARY_DIR}/FDB-610.sh.tmp"
    @ONLY
)

file(GENERATE
    OUTPUT FDB-610.sh
    INPUT "${CMAKE_CURRENT_BINARY_DIR}/FDB-610.sh.tmp"
)

file(CREATE_LINK
    ${CMAKE_CURRENT_SOURCE_DIR}/schema
    ${CMAKE_CURRENT_BINARY_DIR}/schema
    COPY_ON_ERROR
    SYMBOLIC)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/db_store)

ecbuild_add_test(
    TARGET         FDB-610
    TYPE           SCRIPT
    COMMAND        ${CMAKE_CURRENT_BINARY_DIR}/FDB-610.sh
    ENVIRONMENT    "${test_environment}"
)

set_tests_properties(FDB-610
    PROPERTIES
        RESOURCE_LOCK fdb_remote_tests  # Prevent concurrent runs of remote tests
        RUN_SERIAL  TRUE
        LABELS remotefdb
)

=== debian/changelog ===
fdb (5.19.0-1) unstable; urgency=medium

  * Standards-Version: 4.7.3
  * Drop Priority: optional from source in d/control per new policy
  * Add d/gbp.conf
  * New upstream release
  * B-D on python3-sphinxdoc-mermaid, python3-sphinx,autoapi

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Jan 2026 07:59:58 +0000

=== debian/control ===
Source: fdb
Section: utils
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (=13),
 architecture-is-64-bit,
 ecbuild (>= 3.3.0-3),
 libeckit-dev (>= 1.32.3-1~),
 libeccodes-dev,
 libopenjp2-7-dev,
 libmetkit-dev (>= 1.15.3-1~),
 libmetkit-utils ,
 libodc-dev,
 libpmem-dev [amd64 arm64 ppc64el riscv64],
 librados-dev,
 python3-sphinx-book-theme,
 python3-sphinx-autoapi,
 python3-sphinxcontrib-mermaid,
 python3-breathe,
 libeccodes-tools
Standards-Version: 4.7.3
Homepage: https://github.com/ecmwf/fdb
Vcs-Browser: https://salsa.debian.org/science-team/fdb
Vcs-Git: https://salsa.debian.org/science-team/fdb.git -b debian/latest

Package: libfdb5-0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library for the ECMWF Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

Package: libfdb5-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfdb5-0d (= ${binary:Version}), 
  ${misc:Depends}, libeckit-dev
Recommends: pkgconf
Description: Development files for the ECMWF Fields database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
 .
 This package provides shared libraries and headers.

Package: fdb5
Multi-Arch: foreign
Architecture: any
Depends: libfdb5-0d ( = ${binary:Version}), 
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libfdb5-dev (= ${binary:Version})
Description: Utilities for the FDB Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

## fdb 5.19.1

=== requirements.txt ===
zarr>=3,<4
numpy
pytest
pytest-asyncio
eccodes
pyfdb
build
setuptools

=== docs/CMakeLists.txt ===
add_subdirectory(fdb)
add_subdirectory(z3fdb)

=== src/fdb5/CMakeLists.txt ===
ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

configure_file( fdb5_config.h.in    fdb5_config.h   )
configure_file( fdb5_version.h.in   fdb5_version.h  )
configure_file( fdb5_version.c.in   ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c   )

install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fdb5_config.h
               ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.h
         DESTINATION ${INSTALL_INCLUDE_DIR}/fdb5 )

# fdb5 library

list( APPEND fdb5_srcs
    ${CMAKE_CURRENT_BINARY_DIR}/fdb5_version.c
	LibFdb5.h
	LibFdb5.cc

    api/fdb_c.cc
    api/fdb_c.h
    api/DistFDB.cc
    api/DistFDB.h
    api/FDB.cc
    api/FDB.h
    api/FDBFactory.cc
    api/FDBFactory.h
    api/FDBStats.cc
    api/FDBStats.h
    api/LocalFDB.cc
    api/LocalFDB.h
    api/RandomFDB.cc
    api/SelectFDB.cc
    api/SelectFDB.h

    api/helpers/APIIterator.h
    api/helpers/AxesIterator.cc
    api/helpers/AxesIterator.h
    api/helpers/ControlIterator.cc
    api/helpers/ControlIterator.h
    api/helpers/FDBToolRequest.cc
    api/helpers/FDBToolRequest.h
    api/helpers/DumpIterator.h
    api/helpers/ListElement.cc
    api/helpers/ListElement.h
    api/helpers/ListIterator.cc
    api/helpers/ListIterator.h
    api/helpers/LockIterator.h
    api/helpers/MoveIterator.h
    api/helpers/StatusIterator.h
    api/helpers/WipeIterator.h
    api/helpers/PurgeIterator.h
    api/helpers/StatsIterator.cc
    api/helpers/StatsIterator.h
    api/helpers/Callback.h

    api/local/QueryVisitor.h
    api/local/QueueStringLogTarget.h
    api/local/ListVisitor.h
    api/local/AxesVisitor.cc
    api/local/AxesVisitor.h
    api/local/ControlVisitor.cc
    api/local/ControlVisitor.h
    api/local/DumpVisitor.h
    api/local/WipeVisitor.cc
    api/local/WipeVisitor.h
    api/local/MoveVisitor.cc
    api/local/MoveVisitor.h
    api/local/PurgeVisitor.cc
    api/local/PurgeVisitor.h
    api/local/StatsVisitor.cc
    api/local/StatsVisitor.h
    api/local/StatusVisitor.h

    config/Config.cc
    config/Config.h
    database/Archiver.cc
    database/Archiver.h
    database/ArchiveVisitor.cc
    database/ArchiveVisitor.h
    database/AxisRegistry.cc
    database/AxisRegistry.h
    database/BaseArchiveVisitor.cc
    database/BaseArchiveVisitor.h
    database/BaseKey.cc
    database/BaseKey.h
    database/Catalogue.cc
    database/Catalogue.h
    database/DatabaseNotFoundException.cc
    database/DatabaseNotFoundException.h
    database/DataStats.cc
    database/DataStats.h
    database/DbStats.cc
    database/DbStats.h
    database/Engine.cc
    database/Engine.h
    database/EntryVisitMechanism.cc
    database/EntryVisitMechanism.h
    database/Field.cc
    database/Field.h
    database/FieldDetails.cc
    database/FieldDetails.h
    database/FieldLocation.cc
    database/FieldLocation.h
    database/UriStore.cc
    database/UriStore.h
    database/Indexer.cc
    database/Indexer.h
    database/Index.cc
    database/Index.h
    database/IndexLocation.cc
    database/IndexLocation.h
    database/IndexStats.cc
    database/IndexStats.h
    database/Inspector.cc
    database/Inspector.h
    database/StatsReportVisitor.cc
    database/StatsReportVisitor.h
    database/Store.cc
    database/Store.h
    database/PurgeVisitor.cc
    database/PurgeVisitor.h
    database/WipeVisitor.cc
    database/WipeVisitor.h
    database/MoveVisitor.cc
    database/MoveVisitor.h
    database/IndexAxis.cc
    database/IndexAxis.h
    database/IndexFactory.cc
    database/IndexFactory.h
    database/Key.cc
    database/Key.h
    database/ReadVisitor.cc
    database/ReadVisitor.h
    database/ReindexVisitor.cc
    database/ReindexVisitor.h
    database/Reindexer.cc
    database/Reindexer.h
    database/Report.cc
    database/Report.h
    database/RetrieveVisitor.cc
    database/RetrieveVisitor.h
    database/MultiRetrieveVisitor.cc
    database/MultiRetrieveVisitor.h
    database/WriteVisitor.cc
    database/WriteVisitor.h
    database/Notifier.cc
    database/Notifier.h
    database/Manager.cc
    database/Manager.h
    message/MessageArchiver.cc
    message/MessageArchiver.h
    message/MessageDecoder.cc
    message/MessageDecoder.h
    message/MessageIndexer.cc
    message/MessageIndexer.h
    io/FDBFileHandle.cc
    io/FDBFileHandle.h
    io/LustreSettings.cc
    io/LustreSettings.h
    io/LustreFileHandle.h
    io/HandleGatherer.cc
    io/HandleGatherer.h
    io/FieldHandle.cc
    io/FieldHandle.h
    rules/MatchAlways.cc
    rules/MatchAlways.h
    rules/MatchAny.cc
    rules/MatchAny.h
    rules/Matcher.cc
    rules/Matcher.h
    rules/MatchHidden.cc
    rules/MatchHidden.h
    rules/ExcludeAll.cc
    rules/ExcludeAll.h
    rules/MatchOptional.cc
    rules/MatchOptional.h
    rules/MatchValue.cc
    rules/MatchValue.h
    rules/Predicate.cc
    rules/Predicate.h
    rules/Rule.cc
    rules/Rule.h
    rules/Schema.cc
    rules/Schema.h
    rules/SchemaParser.cc
    rules/SchemaParser.h
    rules/SelectMatcher.cc
    rules/SelectMatcher.h
    tools/FDBTool.cc
    tools/FDBTool.h
    tools/FDBVisitTool.cc
    tools/FDBVisitTool.h
    types/Type.cc
    types/Type.h
    types/TypeAbbreviation.cc
    types/TypeAbbreviation.h
    types/TypeClimateDaily.cc
    types/TypeClimateDaily.h
    types/TypeClimateMonthly.cc
    types/TypeClimateMonthly.h
    types/TypeDate.cc
    types/TypeDate.h
    types/TypeDefault.cc
    types/TypeDefault.h
    types/TypeDouble.cc
    types/TypeDouble.cc
    types/TypeDouble.h
    types/TypeDouble.h
    types/TypeExpver.cc
    types/TypeExpver.h
    types/TypeGrid.cc
    types/TypeGrid.h
    types/TypeIgnore.cc
    types/TypeIgnore.h
    types/TypeInteger.cc
    types/TypeInteger.h
    types/TypeMonth.cc
    types/TypeMonth.h
    types/TypeMonthOfDate.cc
    types/TypeMonthOfDate.h
    types/TypeYear.cc
    types/TypeYear.h
    types/TypeParam.cc
    types/TypeParam.h
    types/TypesFactory.cc
    types/TypesFactory.h
    types/TypesRegistry.cc
    types/TypesRegistry.h
    types/TypeStep.cc
    types/TypeStep.h
    types/TypeTime.cc
    types/TypeTime.h
)

if(HAVE_FDB_REMOTE)
    list( APPEND fdb5_srcs
        api/RemoteFDB.cc
        api/RemoteFDB.h

        remote/Connection.h
        remote/Connection.cc
        remote/RemoteFieldLocation.h
        remote/RemoteFieldLocation.cc
        remote/Messages.h
        remote/Messages.cc
        remote/FdbServer.h
        remote/FdbServer.cc
        remote/RemoteConfiguration.h
        remote/RemoteConfiguration.cc

        remote/client/Client.h
        remote/client/Client.cc
        remote/client/ClientConnection.h
        remote/client/ClientConnection.cc
        remote/client/ClientConnectionRouter.h
        remote/client/ClientConnectionRouter.cc
        remote/client/RemoteStore.cc
        remote/client/RemoteStore.h
        remote/client/RemoteCatalogue.h
        remote/client/RemoteCatalogue.cc
        remote/client/ReadLimiter.h
        remote/client/ReadLimiter.cc

        remote/server/AvailablePortList.cc
        remote/server/AvailablePortList.h
        remote/server/CatalogueHandler.h
        remote/server/CatalogueHandler.cc
        remote/server/StoreHandler.h
        remote/server/StoreHandler.cc
        remote/server/ServerConnection.h
        remote/server/ServerConnection.cc
    )
endif()

if(fdb5_HAVE_LUSTRE)
  list( APPEND fdb5_srcs io/fdb5_lustreapi_file_create.c )
endif()

if ( HAVE_GRIB )
    list( APPEND fdb5_srcs
        io/SingleGribMungePartFileHandle.cc
        io/SingleGribMungePartFileHandle.h
    )
endif()

if( HAVE_TOCFDB )
    list( APPEND fdb5_srcs
        toc/AdoptVisitor.cc
        toc/AdoptVisitor.h
        toc/BTreeIndex.cc
        toc/BTreeIndex.h
        toc/Root.cc
        toc/Root.h
        toc/FieldRef.cc
        toc/FieldRef.h
        toc/FileSpaceHandler.cc
        toc/FileSpaceHandler.h
        toc/FileSpace.cc
        toc/FileSpace.h
        toc/ExpverFileSpaceHandler.cc
        toc/ExpverFileSpaceHandler.h
        toc/EnvVarFileSpaceHandler.cc
        toc/EnvVarFileSpaceHandler.h
        toc/RootManager.cc
        toc/RootManager.h
        toc/TocCommon.cc
        toc/TocCommon.h
        toc/TocCatalogue.cc
        toc/TocCatalogue.h
        toc/TocCatalogueReader.cc
        toc/TocCatalogueReader.h
        toc/TocCatalogueWriter.cc
        toc/TocCatalogueWriter.h
        toc/TocFieldLocation.cc
        toc/TocFieldLocation.h
        toc/TocHandler.cc
        toc/TocHandler.h
        toc/TocIndex.cc
        toc/TocIndex.h
        toc/TocIndexLocation.cc
        toc/TocIndexLocation.h
        toc/TocPurgeVisitor.cc
        toc/TocPurgeVisitor.h
        toc/TocSerialisationVersion.cc
        toc/TocSerialisationVersion.h
        toc/TocWipeVisitor.cc
        toc/TocWipeVisitor.h
        toc/TocMoveVisitor.cc
        toc/TocMoveVisitor.h
        toc/TocRecord.cc
        toc/TocRecord.h
        toc/TocStats.cc
        toc/TocStats.h
        toc/TocStore.cc
        toc/TocStore.h
        toc/TocEngine.cc
        toc/TocEngine.h
        )

    list( APPEND fdb5_tools
        fdb-wipe
        fdb-stats
        fdb-purge
        fdb-dump-toc
        fdb-dump-index
        fdb-move
        fdb-reconsolidate-toc )
endif()

if( HAVE_RADOSFDB )
    list( APPEND fdb5_srcs
        rados/RadosFieldLocation.cc
        rados/RadosFieldLocation.h
        rados/RadosStore.cc
        rados/RadosStore.h
    )
endif()

if( HAVE_DAOSFDB )
    list( APPEND fdb5_srcs
        daos/DaosOID.cc
        daos/DaosOID.h
        daos/DaosName.cc
        daos/DaosName.h
        daos/DaosObject.cc
        daos/DaosObject.h
        daos/DaosContainer.cc
        daos/DaosContainer.h
        daos/DaosPool.cc
        daos/DaosPool.h
        daos/DaosSession.cc
        daos/DaosSession.h
        daos/DaosArrayHandle.cc
        daos/DaosArrayHandle.h
        daos/DaosKeyValueHandle.cc
        daos/DaosKeyValueHandle.h
        daos/DaosStore.h
        daos/DaosStore.cc
        daos/DaosFieldLocation.h
        daos/DaosFieldLocation.cc
        daos/DaosException.h
        daos/DaosException.cc
        daos/DaosEngine.h
        daos/DaosEngine.cc
        daos/DaosCatalogue.h
        daos/DaosCatalogue.cc
        daos/DaosCatalogueWriter.h
        daos/DaosCatalogueWriter.cc
        daos/DaosCatalogueReader.h
        daos/DaosCatalogueReader.cc
        daos/DaosIndex.h
        daos/DaosIndex.cc
        daos/DaosIndexLocation.h
        daos/DaosIndexLocation.cc
        daos/DaosCommon.h
        daos/DaosCommon.cc
        daos/DaosWipeVisitor.h
        daos/DaosWipeVisitor.cc
        daos/DaosArrayPartHandle.h
        daos/DaosArrayPartHandle.cc
        daos/DaosLazyFieldLocation.h
        daos/DaosLazyFieldLocation.cc
        daos/UUID.h
        daos/UUID.cc
    )
else()
    set( DAOS_LIBRARIES "" )
    set( DAOS_INCLUDE_DIRS "" )
    set( UUID_LIBRARIES "" )
    set( UUID_INCLUDE_DIRS "" )
endif()

ecbuild_add_library(

    TARGET  fdb5

    TYPE SHARED # Library needs to be shared for dynamic factory self registration

    SOURCES
        ${fdb5_srcs}

    INSTALL_HEADERS LISTED

    HEADER_DESTINATION
        ${INSTALL_INCLUDE_DIR}/fdb5

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>

    PUBLIC_LIBS
        metkit
        eckit
        eckit_option
        "${UUID_LIBRARIES}"

    PRIVATE_INCLUDES
        "${LUSTREAPI_INCLUDE_DIRS}"
        "${DAOS_INCLUDE_DIRS}"
        "${DAOS_TESTS_INCLUDE_DIRS}"

    PRIVATE_LIBS
        ${LUSTREAPI_LIBRARIES}
        "${DAOS_LIBRARIES}"
        "${DAOS_TESTS_LIBRARIES}"
        $<$<BOOL:${HAVE_GRIB}>:eccodes>
)

if(HAVE_FDB_BUILD_TOOLS)

  list( APPEND fdb5_scripts fdb fdb-which )

  foreach( _script ${fdb5_scripts} )
    configure_file(scripts/${_script}.in ${CMAKE_BINARY_DIR}/bin/${_script} @ONLY)
    install(PROGRAMS ${CMAKE_BINARY_DIR}/bin/${_script} DESTINATION ${INSTALL_BIN_DIR} )
  endforeach()
endif()

list( APPEND fdb5_tools
    fdb-axes
    fdb-write
    fdb-copy
    fdb-dump
    fdb-list
    fdb-read
    fdb-schema

=== tests/chunked_data_view/CMakeLists.txt ===
list(APPEND tests
    view
    axis
    index_mapper
    builder
)

foreach(test ${tests})
    ecbuild_add_test(
        TARGET chunked_data_view_test_${test}
        SOURCES test_${test}.cc
        LIBS 
            chunked_data_view
            fdb5
            eckit
            metkit
    )
endforeach()

=== tests/z3fdb/CMakeLists.txt ===
function(add_py_test test)
    get_filename_component(stem ${test} NAME_WLE)
    add_test(
        NAME pychunked_data_view_${stem}
        COMMAND ${Python_INTERPRETER}
            -m pytest
            --basetemp ${CMAKE_CURRENT_BINARY_DIR}/pytest-tmp
            -vv -s ${CMAKE_CURRENT_SOURCE_DIR}/${test}
    )
    set(_env
        "PYTHONPATH=${CMAKE_BINARY_DIR}/z3fdb-python-package-staging"
        #prevent findlibs in pyfdb to pickup any globally installed fdb
        "FDB5_DIR=${CMAKE_BINARY_DIR}"
        #prevent findlibs in eccodes-python to pickup any globally installed eccodes
        "FINDLIBS_DISABLE_PACKAGE=yes"
        "ECCODES_DIR=$<TARGET_FILE_DIR:eccodes>/.."
    )
    set_tests_properties(pychunked_data_view_${stem}
        PROPERTIES
        RESOURCE_LOCK pytest
        ENVIRONMENT "${_env}"
        LABELS z3fdb
    )
endfunction()


set(test_files
  test_store_v3.py
  test_store_v3_pattern.py
  test_store_v3_parts.py
  test_store_v3_random_axis.py
)

foreach(test_file ${test_files})
  add_py_test(${test_file})
endforeach()

=== tests/fdb/remote/CMakeLists.txt ===
# Client side of test
ecbuild_add_executable(
    TARGET    fdb_test_remote_api_bin
    SOURCES   test_remote_api.cc
    INCLUDES  ${ECKIT_INCLUDE_DIRS}
    LIBS      fdb5
    NOINSTALL
)

if (HAVE_FDB_BUILD_TOOLS AND HAVE_GRIB)
    ecbuild_configure_file( test_server.sh.in fdb_test_server.sh @ONLY )
    set(FDB_TEST_SERVER_SCRIPT "${CMAKE_CURRENT_BINARY_DIR}/fdb_test_server.sh" CACHE INTERNAL "")

    # Basic API test using "standard" configuration
    ecbuild_configure_file( catalogue.yaml.in catalogue.yaml @ONLY )
    ecbuild_configure_file( store.yaml.in store.yaml @ONLY )
    ecbuild_configure_file( client.yaml.in client.yaml @ONLY )

    ecbuild_add_test(
        TARGET         fdb_test_remote_api
        TYPE           SCRIPT
        COMMAND        ${FDB_TEST_SERVER_SCRIPT}
        ARGS           ${CMAKE_CURRENT_BINARY_DIR} client.yaml catalogue.yaml store.yaml
        TEST_DEPENDS   fdb_test_remote_api_bin
        ENVIRONMENT    "${test_environment}"
    )
    # if (TARGET fdb_test_remote_api)
    set_tests_properties(fdb_test_remote_api
        PROPERTIES TIMEOUT 300
        RESOURCE_LOCK fdb_remote_tests  # Prevent concurrent runs of remote tests
        RUN_SERIAL  TRUE
        LABELS remotefdb
    )
    # endif()
endif()

=== tests/regressions/FDB-240/CMakeLists.txt ===
ecbuild_configure_file( FDB-240.sh.in FDB-240.sh @ONLY )
ecbuild_get_test_multidata(TARGET download_fdb5_regression_tests_files NAMES sh.300.grib NOCHECK )

ecbuild_add_test(
    TYPE     SCRIPT
    TEST_DEPENDS download_fdb5_regression_tests_files
    COMMAND  FDB-240.sh
    ENVIRONMENT "${test_environment}" )

=== tests/regressions/FDB-419/CMakeLists.txt ===

set(SCHEMA_PATH ${CMAKE_CURRENT_SOURCE_DIR}/schema)
set(SPACE_ROOT_PATH ${CMAKE_CURRENT_BINARY_DIR})
ecbuild_configure_file(
    fdb_client_config.yaml.in
    fdb_client_config.yaml
    @ONLY
)
ecbuild_configure_file(
    fdb_server_config.yaml.in
    fdb_server_config.yaml
    @ONLY
)

ecbuild_add_test( 
    TARGET FDB-419
    SOURCES fdb_419_regression_test.cc
    LIBS fdb5 eckit metkit
    ENVIRONMENT FDB_SERVER_EXECUTABLE=$<TARGET_FILE:fdb-server>
    ENVIRONMENT "${test_environment}"
)

# if (TARGET FDB-419)
set_tests_properties(FDB-419
    PROPERTIES 
    RESOURCE_LOCK fdb_remote_tests  # Prevent concurrent runs of remote tests
    RUN_SERIAL  TRUE
    LABELS remotefdb
)
# endif()

=== tests/regressions/FDB-491/CMakeLists.txt ===
# Run remote API tests, but with the singleConnection option set in the server configs

if (NOT DEFINED FDB_TEST_SERVER_SCRIPT)
    message(FATAL_ERROR "FDB_TEST_SERVER_SCRIPT is not defined. Please ensure the test server script is configured correctly.")
endif()

ecbuild_configure_file( catalogue.yaml.in catalogue.yaml @ONLY )
ecbuild_configure_file( store.yaml.in store.yaml @ONLY )
ecbuild_configure_file( client.yaml.in client.yaml @ONLY )

ecbuild_add_test(
    TARGET         FDB-491-remote-single-connection
    TYPE           SCRIPT
    COMMAND        ${FDB_TEST_SERVER_SCRIPT}
    ARGS           ${CMAKE_CURRENT_BINARY_DIR} client.yaml catalogue.yaml store.yaml
    TEST_DEPENDS   fdb_test_remote_api_bin
    ENVIRONMENT    "${test_environment}"
)

# if (TARGET FDB-491-remote-single-connection)
set_tests_properties(FDB-491-remote-single-connection 
    PROPERTIES TIMEOUT 300
    RESOURCE_LOCK fdb_remote_tests  # Prevent concurrent runs of remote tests
    RUN_SERIAL  TRUE
    LABELS remotefdb
)
# endif()

=== tests/regressions/FDB-595/CMakeLists.txt ===
# Run remote API tests, but with the singleConnection option set in the server configs

ecbuild_configure_file( FDB-595.sh.in FDB-595.sh @ONLY )

ecbuild_add_test(
    TARGET         FDB-595
    TYPE           SCRIPT
    COMMAND        ${CMAKE_CURRENT_BINARY_DIR}/FDB-595.sh
    ENVIRONMENT    "${test_environment}"
)

set_tests_properties(FDB-595
    PROPERTIES
        RESOURCE_LOCK fdb_remote_tests  # Prevent concurrent runs of remote tests
        RUN_SERIAL  TRUE
        LABELS remotefdb
)

=== debian/changelog ===
fdb (5.19.1-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Add new files under CC-BY-4.0 license
  * Add header to patch
  * d/gbp.conf: use pristine-tar

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 Feb 2026 09:01:41 +0000

=== debian/control ===
Source: fdb
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Alastair McKinstry <mckinstry@debian.org>,
Section: utils
Build-Depends:
 debhelper-compat (=13),
 architecture-is-64-bit,
 ecbuild,
 libeckit-dev (>= 1.32.3-1~),
 libeccodes-dev,
 libopenjp2-7-dev,
 libmetkit-dev (>= 1.15.3-1~),
 libmetkit-utils,
 libodc-dev,
 libpmem-dev [amd64 arm64 ppc64el riscv64],
 librados-dev,
 python3-sphinx-book-theme,
 python3-sphinx-autoapi,
 python3-sphinxcontrib-mermaid,
 python3-breathe,
 libeccodes-tools,
Vcs-Browser: https://salsa.debian.org/science-team/fdb
Vcs-Git: https://salsa.debian.org/science-team/fdb.git -b debian/latest
Homepage: https://github.com/ecmwf/fdb

Package: libfdb5-0d
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Library for the ECMWF Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.

Package: libfdb5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libfdb5-0d (= ${binary:Version}),
 ${misc:Depends},
 libeckit-dev,
Recommends:
 pkgconf,
Description: Development files for the ECMWF Fields database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
 .
 This package provides shared libraries and headers.

Package: fdb5
Architecture: any
Multi-Arch: foreign
Depends:
 libfdb5-0d ( = ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Recommends:
 libfdb5-dev (= ${binary:Version}),
Description: Utilities for the FDB Fields Database
 FDB (Fields DataBase) is a domain-specific object store developed
 at ECMWF for storing, indexing and retrieving GRIB data. 
 Each GRIB message is stored as a field and indexed trough semantic metadata
 (i.e. physical variables such as temperature, pressure, ...).
 A set of fields can be retrieved specifying a request using
 a specific language developed for accessing the MARS Archive.
